package com.lukouguoji.gjc.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import com.alibaba.android.arouter.facade.annotation.Route
import com.lukouguoji.gjc.R
import com.lukouguoji.gjc.databinding.ActivityGjcAssembleAllocateBinding
import com.lukouguoji.gjc.viewModel.GjcAssembleAllocateViewModel
import com.lukouguoji.module_base.base.BaseBindingActivity
import com.lukouguoji.module_base.common.ConstantEvent
import com.lukouguoji.module_base.impl.FlowBus
import com.lukouguoji.module_base.impl.observe
import com.lukouguoji.module_base.ktx.getLifecycleOwner
import com.lukouguoji.module_base.router.ARouterConstants

/**
 * 国际出港组装分配列表页
 */
@Route(path = ARouterConstants.ACTIVITY_URL_GJC_ASSEMBLE_ALLOCATE)
class GjcAssembleAllocateActivity :
    BaseBindingActivity<ActivityGjcAssembleAllocateBinding, GjcAssembleAllocateViewModel>() {

    override fun layoutId() = R.layout.activity_gjc_assemble_allocate

    override fun viewModelClass() = GjcAssembleAllocateViewModel::class.java

    override fun initOnCreate(savedInstanceState: Bundle?) {
        setBackArrow("国际出港组装分配")

        binding.viewModel = viewModel

        // 绑定分页逻辑
        viewModel.pageModel
            .bindSmartRefreshLayout(binding.srl, binding.rv, viewModel, getLifecycleOwner())

        // 监听刷新事件
        FlowBus.with<String>(ConstantEvent.EVENT_REFRESH)
            .observe(this) {
                viewModel.refresh()
            }

        // 监听checkbox状态变化事件
        FlowBus.with<String>(ConstantEvent.EVENT_CHECK_CHANGED)
            .observe(this) {
                viewModel.onItemCheckChanged()
            }

        // 初始化：获取分配人列表
        viewModel.getAssembleCompanyList()

        // 初始加载
        viewModel.refresh()
    }

    companion object {
        @JvmStatic
        fun start(context: Context) {
            val starter = Intent(context, GjcAssembleAllocateActivity::class.java)
            context.startActivity(starter)
        }
    }
}
